﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Interpreter.Ast;

namespace DeyjaScript
{
    class AssignmentNode : ExpressionNode
    {
        public override void Init(Irony.Parsing.ParsingContext context, Irony.Parsing.ParseTreeNode treeNode)
        {
            base.Init(context, treeNode);
            AddChild("LValue", treeNode.ChildNodes[0]);
            AddChild("RValue", treeNode.ChildNodes[2]);
            this.AsString = "Assignment";
        }

        internal override string getResultType(ExecutionContext context)
        {
            return (ChildNodes[0] as ExpressionNode).getResultType(context);
        }

        public override void gatherInformation(ExecutionContext context)
        {
            var LValue = ChildNodes[0] as LValue;
            if (LValue == null) throw new CompileError("Only assignment to LValues is allowed.");
            if ((ChildNodes[0] as ExpressionNode).getResultType(context) != (ChildNodes[1] as ExpressionNode).getResultType(context))
                throw new CompileError("Assignment type mismatch");
            (ChildNodes[0] as ExpressionNode).gatherInformation(context);
            (ChildNodes[1] as ExpressionNode).gatherInformation(context);
        }

        public override void emitByteCode(List<byte> bytecode, ExecutionContext context)
        {
            (ChildNodes[1] as ExpressionNode).emitByteCode(bytecode, context);
            (ChildNodes[0] as LValue).emitAssignmentByteCode(bytecode, context);
        }
    }

    
}
