﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Interpreter.Ast;

namespace DeyjaScript
{
    class IdentifierNode : ExpressionNode, LValue
    {
        int variableIndex = 0;

        public override void Init(Irony.Parsing.ParsingContext context, Irony.Parsing.ParseTreeNode treeNode)
        {
            base.Init(context, treeNode);
            this.AsString = treeNode.FindTokenAndGetText();
        }

        internal override string getResultType(ExecutionContext context)
        {
            var variable = context.currentScope.findVariable(AsString);
            if (variable == null) throw new CompileError("Undefined variable");
            return variable.getResultType(context);
        }

        public override void gatherInformation(ExecutionContext context)
        {
            var variable = context.currentScope.findVariable(AsString);
            if (variable == null) throw new CompileError("Undefined variable");
            variableIndex = variable.variableIndex;
        }

        public override void emitByteCode(List<byte> bytecode, ExecutionContext context)
        {
            bytecode.Add((byte)Instruction.pushVar);
            bytecode.Add((byte)variableIndex);
        }

        void LValue.emitAssignmentByteCode(List<byte> bytecode, ExecutionContext context)
        {
            bytecode.Add((byte)Instruction.popVar);
            bytecode.Add((byte)variableIndex);
        }
    }

    
}
