﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Interpreter.Ast;

namespace DeyjaScript
{
    class IntLiteralNode : ExpressionNode
    {
        public override void Init(Irony.Parsing.ParsingContext context, Irony.Parsing.ParseTreeNode treeNode)
        {
            base.Init(context, treeNode);
            this.AsString = treeNode.FindTokenAndGetText();
        }

        internal override string getResultType(ExecutionContext context)
        {
            return "int";
        }

        public override void gatherInformation(ExecutionContext context)
        {

        }

        public override void emitByteCode(List<byte> bytecode, ExecutionContext context)
        {
            var intBytes = BitConverter.GetBytes(Convert.ToInt32(AsString));
            bytecode.Add((byte)Instruction.pushInt);
            bytecode.AddRange(intBytes);
        }
    }

    
}
