﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DeyjaScript
{
    internal class Scope
    {
        internal List<VariableDeclarationNode> variables = new List<VariableDeclarationNode>();
        internal VariableDeclarationNode findVariable(String name)
        {
            foreach (var node in variables) if (node.AsString == name) return node;
            return null;
        }
        internal void addVariable(VariableDeclarationNode node)
        {
            if (findVariable(node.AsString) != null) throw new CompileError("Variable already defined in this scope.");
            variables.Add(node);
            node.variableIndex = variables.Count - 1;
        }
    }
}
