﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DeyjaScript
{
    class Stack
    {
        internal object[] data = new object[1024];
        internal int topPointer = 0;
        internal int framePointer = 0;
        
        internal void push(object obj)
        {
            if (topPointer >= data.Length - 1) throw new RuntimeError("Stack overflow");
            data[topPointer] = obj;
            ++topPointer;
        }

        internal void pushN(int count)
        {
            for (int i = 0; i < count; ++i) push(null);
        }

        internal void pop()
        {
            if (topPointer == 0) throw new RuntimeError("Stack underflow");
            --topPointer;
        }

        internal void popN(int count)
        {
            for (int i = 0; i < count; ++i) pop();
        }

        internal object fetch(int index)
        {
            if (index < 0 || index >= 1024) throw new RuntimeError("Stack index out of range");
            return data[index];
        }

        internal void store(int index, Object obj)
        {
            if (index < 0 || index >= 1024) throw new RuntimeError("Stack index out of range");
            data[index] = obj;
        }

        internal void clear() { topPointer = 0; framePointer = 0; }
    }
}
