﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Irony.Interpreter.Ast;

namespace DeyjaScript
{
    class VariableDeclarationNode : ExpressionNode
    {
        internal int variableIndex = 0;

        public override void Init(Irony.Parsing.ParsingContext context, Irony.Parsing.ParseTreeNode treeNode)
        {
            base.Init(context, treeNode);
            AddChild("Type", treeNode.ChildNodes[0]);
            AddChild("Name", treeNode.ChildNodes[1]);
            AsString = treeNode.ChildNodes[1].FindTokenAndGetText();
        }

        internal override string getResultType(ExecutionContext context)
        {
            return ChildNodes[0].AsString;
        }

        public override void gatherInformation(ExecutionContext context)
        {
            context.currentScope.addVariable(this);
        }

        public override void emitByteCode(List<byte> bytecode, ExecutionContext context)
        {
            //Emit initialization statements when implemented
        }
    }
}
